package cn.com.infosec.asn1;

import java.io.OutputStream;

public class BEROctetStringGenerator extends BERGenerator {
   public BEROctetStringGenerator(OutputStream out) {
      super(out);
      this.writeBERHeader(36);
   }

   public BEROctetStringGenerator(OutputStream out, int tagNo, boolean isExplicit) {
      super(out, tagNo, isExplicit);
      this.writeBERHeader(36);
   }

   public OutputStream getOctetOutputStream() {
      return this.getOctetOutputStream(new byte[1000]);
   }

   public OutputStream getOctetOutputStream(byte[] buf) {
      return new BufferedBEROctetStream(buf);
   }

   private class BufferedBEROctetStream extends OutputStream {
      private byte[] _buf;
      private int _off;

      BufferedBEROctetStream(byte[] buf) {
         this._buf = buf;
         this._off = 0;
      }

      public void write(int b) {
         byte[] var2 = this._buf;
         int var3;
         int var4;
         int var10000 = var4 = (var3 = this._off) + 1;
         this._off = var4;
         var2[var3] = (byte)b;
         if (var10000 == var2.length) {
            BEROctetStringGenerator.super._out.write((new DEROctetString(var2)).getEncoded());
            this._off = 0;
         }

      }

      public void write(byte[] b, int off, int len) {
         while(true) {
            if (len > 0) {
               int var4 = Math.min(len, this._buf.length - this._off);
               byte[] var5 = this._buf;
               System.arraycopy(b, off, var5, this._off, var4);
               int var6;
               int var10000 = var6 = this._off + var4;
               this._off = var6;
               if (var10000 >= (var5 = this._buf).length) {
                  BEROctetStringGenerator.super._out.write((new DEROctetString(var5)).getEncoded());
                  this._off = 0;
                  off += var4;
                  len -= var4;
                  continue;
               }
            }

            return;
         }
      }

      public void close() {
         int var1;
         if ((var1 = this._off) != 0) {
            byte[] var2 = new byte[var1];
            System.arraycopy(this._buf, 0, var2, 0, var1);
            BEROctetStringGenerator.super._out.write((new DEROctetString(var2)).getEncoded());
         }

         BEROctetStringGenerator.this.writeBEREnd();
      }
   }
}
